unit cunit;

interface

uses
  Windows, Messages, SysUtils,registry,
  Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, shellapi;
const
  WM_MIDASICON  = WM_USER + 1;
  X_CAPTION_MIN = '';
  X_CAPTION_MAX = '';
  DayNames:array [1..7] of string=(
                 '','','',
                 '','','',
                 '');
type
  Tcform = class(TForm)
    tictac: TTimer;
    xmenu: TPopupMenu;
    xexit: TMenuItem;
    xfd: TFontDialog;
    xfont: TMenuItem;
    aitem: TMenuItem;
    cdlg: TColorDialog;
    bgc: TMenuItem;
    imin: TMenuItem;
    N1: TMenuItem;
    xxx1: TMenuItem;
    sDate: TMenuItem;
    setd: TMenuItem;
    auto: TMenuItem;
    N4: TMenuItem;
    procedure clsButtonClick(Sender: TObject);
    procedure tictacTimer(Sender: TObject);
    procedure xlMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure xlMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure xlMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure xfontClick(Sender: TObject);
    procedure xfdApply(Sender: TObject; Wnd: Integer);
    procedure aitemClick(Sender: TObject);
    procedure bgcClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure iminClick(Sender: TObject);
    procedure xlDblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure sDateClick(Sender: TObject);
    procedure setdClick(Sender: TObject);
    procedure autoClick(Sender: TObject);
    procedure N4Click(Sender: TObject);
  private
    { Private declarations }
    mvd:boolean;
    ox:integer;
    oy:integer;
    mx:integer;
    my:integer;
    xtime:ShortString;
    Nid:TNotifyIconDataA;
    procedure sizeByFont;
  public
    { Public declarations }
    procedure SetTrayIcon;
    procedure WinMenager(Sender: TObject);
    procedure xwin(var Message: TMessage);
                   message WM_MIDASICON;
  end;
  TXClockSetups=record
   left,top,width,height:integer;
   fontc:TColor;
   fstyle:TFontStyles;
   charset:TFontCharset;
   fname:shortstring;
   fsize:integer;
   bgcolor:TColor;
   showDate:boolean;
   autorun:boolean;
  end;
  TXClockSetupsFile=file of TXClockSetups;
var
  cform: Tcform;

implementation

uses aunt, sunit, pathu, cal;

{$R *.DFM}
 function ask(str:string):boolean;
 begin
  Result:=(MessageDlg(str,mtConfirmation,[mbYes,mbNo],0)=mrYes)
 end;
procedure Tcform.FormCreate(Sender: TObject);
 var
  xf:TXClockSetupsFile;
  txcs:TXClockSetups;
  reg:TRegIniFile;
begin
 Application.OnMinimize:=WinMenager;
 Application.OnRestore :=WinMenager;
 imin.Caption:=X_CAPTION_MIN;
 SetTrayIcon;
 xtime:='';
 {$I-}
  AssignFile(xf,exepath+'xclock.txcs');
  reset(xf);
  read(xf,txcs);
 {$I+}
  if(IOResult=0)then
   with txcs do begin         
   Canvas.brush.Color:=bgcolor;
   Canvas.Font.Color:=fontc;
   Canvas.pen.Color:=fontc;
   Canvas.Font.Style:=fstyle;
   Canvas.Font.Charset:=charset;
   Canvas.Font.Name:=fname;
   Canvas.Font.Size:=fsize;
   Canvas.pen.Color:=FontC;
   self.top:=top;
   self.left:=left;
   sDate.Checked:=showDate;
   auto.Checked:=autorun;
   CloseFile(xf);
  end else with Canvas do begin
   brush.Color:=clBlack;
   Font.Color:=clRed;
   pen.Color:=clRed;
   Font.Style:=[fsBold];
   Font.Charset:=DEFAULT_CHARSET;
   Font.Name:='Courier New';
   Font.Size:=24;
   sDate.Checked:=false;
   auto.Checked:=false;
  end;
 if auto.Checked then begin
  reg:=TRegIniFile.Create('Software');
  reg.RootKey:=HKEY_CURRENT_USER;
  try
   with reg do begin
    OpenKey('Microsoft',true);
    OpenKey('Windows',true);
    OpenKey('CurrentVersion',true);
    WriteString('Run',
             'Ma[X]iM Software Clock',Application.ExeName);
   end;
  finally
   reg.Free;
  end;
 end;
 sizeByFont;
 Canvas.pen.Width:=3;
 paint;
end;

procedure Tcform.FormDestroy(Sender: TObject);
 var
  xf:TXClockSetupsFile;
  txcs:TXClockSetups;
begin
 Shell_NotifyIcon(NIM_DELETE,@nid);
 {$I-}
  AssignFile(xf,exepath+'xclock.txcs');
  rewrite(xf);
 {$I+}
  if(IOResult=0)then begin
   txcs.bgcolor:=Canvas.brush.Color;
   txcs.fontc:=Canvas.Font.Color;
   txcs.fstyle:=Canvas.Font.Style;
   txcs.charset:=Canvas.Font.Charset;
   txcs.fname:=Canvas.Font.Name;
   txcs.fsize:=Canvas.Font.Size;
   txcs.top:=top;
   txcs.left:=left;
   txcs.width:=width;
   txcs.height:=height;
   txcs.showDate:=sDate.Checked;
   txcs.autorun:=auto.Checked;
   write(xf,txcs);
   CloseFile(xf);
  end;
end;

procedure Tcform.xfontClick(Sender: TObject);
 var oc:TColor;
begin
 xfd.Font:=Canvas.Font;
 if xfd.Execute then begin
  oc:=Canvas.pen.Color;
  Canvas.Font:=xfd.Font;
  Canvas.pen.Color:=oc;
  Canvas.Font.Color:=oc;
  sizeByFont;
  paint;
 end;
end;

procedure Tcform.xfdApply(Sender: TObject; Wnd: Integer);
 var oc:TColor;
begin
 oc:=Canvas.pen.Color;
 Canvas.Font:=xfd.Font;
 Canvas.pen.Color:=oc;
 Canvas.Font.Color:=oc;
 sizeByFont;
 paint;
end;

procedure Tcform.bgcClick(Sender: TObject);
begin
 cdlg.Color:=Canvas.brush.Color;
 if cdlg.Execute then begin
  Canvas.brush.Color:=cdlg.Color;
  paint;
 end;
end;
procedure Tcform.N1Click(Sender: TObject);
 var oc:TColor;
begin
 cdlg.Color:=Canvas.Font.Color;
 if cdlg.Execute then begin
  oc:=cdlg.Color;
  Canvas.pen.Color:=oc;
  Canvas.Font.Color:=cdlg.Color;
  paint;
 end;
end;
procedure Tcform.FormPaint(Sender: TObject);
 var
  tmp:string;
begin
 with Canvas do begin
  Brush.Style:=bsSolid;
  Rectangle(0,0,width,height);
  tmp:=xtime;
  if sDate.Checked then
   tmp:=tmp+' '+DateToStr(Date)+' '+dayNames[dayofweek(date)];
  my:=(Height - TextHeight(tmp))div 2;
  mx:=(Width - TextWidth(tmp))div 2;
  TextOut(mx,my,tmp);
 end;
end;

procedure Tcform.iminClick(Sender: TObject);
begin
 with imin do
  if Caption=X_CAPTION_MIN then begin
   hide;
   Caption:=X_CAPTION_MAX;
  end else begin
   show;
   Caption:=X_CAPTION_MIN;
  end;
end;

procedure Tcform.xlDblClick(Sender: TObject);
begin
 abox.ShowModal;
end;

procedure Tcform.FormActivate(Sender: TObject);
begin
 WinMenager(sender);
end;
procedure Tcform.clsButtonClick(Sender: TObject);
begin
 close;
end;

procedure Tcform.tictacTimer(Sender: TObject);
var
 s:ShortString;
 i:byte;
begin
 s:=TimeToStr(Time);
 if s<>xtime then with nid do begin
  xtime:=s;
  s:='[:- '+s+' '+DateToStr(Date)+' '+dayNames[dayofweek(date)]+' -:]';
  self.Hint:=s;
  self.Caption:=s;
  for i:=1 to length(s) do
   szTip[i-1]:=s[i];
  szTip[length(s)]:=#0;
  Shell_NotifyIconA(NIM_MODIFY,@nid);
  paint;
 end;
end;

procedure Tcform.xlMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mvd:=true;
 ox:=x;
 oy:=y;
end;

procedure Tcform.xlMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mvd:=False;       
end;

procedure Tcform.xlMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
 var
  dx,dy:integer;
 const
  dmax=15;
 function inRange(x:integer):boolean;
 begin
  Result:=(((x>0)and(x<=dmax))or((x<0)and(-x<=dmax)));
 end;
begin
 if (mvd) then begin
  dx:=x-ox;
  dy:=y-oy;
  if inRange(dy)then begin
   if((top+height)>=(screen.Height-dmax))and
     ((top+height)<=(screen.Height+dmax))then begin
    top:=screen.Height-height;
   end else if(top>=-dmax)and(top<=dmax)then begin
    top:=0;
   end else
   top:=self.top+dy;
  end else
   top:=self.top+dy;
  if inRange(dx)then begin
   if((left+width)>=(screen.width-dmax))and
     ((left+width)<=(screen.width+dmax))then begin
    left:=screen.width-width;
   end else if(left>=-dmax)and(left<=dmax)then begin
    left:=0;
   end else
   left:=self.left+dx;
  end else
   left:=self.left+dx;
 end;
end;

procedure Tcform.aitemClick(Sender: TObject);
begin
 abox.Show;
end;
procedure Tcform.sizeByFont;
begin
 with Canvas do begin
  self.width :=TextWidth ('00:00:00')+4;
  if sDate.Checked then
   self.Width :=self.Width+TextWidth('_______________________');
  self.Height:=TextHeight('00:00:00')+4;
 end;
end;
procedure Tcform.WinMenager(Sender: TObject);
begin
 ShowWindowAsync(Application.Handle,SW_HIDE);
end;
procedure Tcform.xwin(var Message: TMessage);
var
  pt: TPoint;
begin
  case Message.LParam of
    WM_RBUTTONUP:
    begin
      SetForegroundWindow(Handle);
      GetCursorPos(pt);
      xMenu.Popup(pt.x, pt.y);
    end;
    WM_LBUTTONUP: begin 
      SetForegroundWindow(Handle);
      iminClick(self);
    end;
  end;
 message.Result:=0;
end;

procedure Tcform.SetTrayIcon;
begin
 with nid do begin
  cbSize:=sizeof(nid);
  Wnd:=self.Handle;
  uID:=self.handle;
  uFlags:= NIF_MESSAGE or NIF_ICON or NIF_TIP;
  uCallbackMessage:=WM_MIDASICON;
  hIcon:=Application.Icon.Handle;
  szTip:='[:- WASSUP! -:]';
 end;
 Shell_NotifyIconA(NIM_ADD,@nid);
end;

procedure Tcform.sDateClick(Sender: TObject);
begin
 sDate.Checked:=not sDate.Checked;
 sizeByFont;
 paint;
end;

procedure Tcform.setdClick(Sender: TObject);
begin
 setDateForm.Execute;
end;

procedure Tcform.autoClick(Sender: TObject);
 var
  reg:TRegIniFile;
begin
 reg:=TRegIniFile.Create('Software');
 reg.RootKey:=HKEY_CURRENT_USER;
 try
  if auto.Checked then begin
   auto.Checked:=false;
   with reg do begin
    OpenKey('Microsoft',true);
    OpenKey('Windows',true);
    OpenKey('CurrentVersion',true);
    OpenKey('Run',true);
    DeleteValue('Ma[X]iM Software Clock');
   end;
  end else begin
   auto.Checked:=true;
   with reg do begin
    OpenKey('Microsoft',true);
    OpenKey('Windows',true);
    OpenKey('CurrentVersion',true);
    WriteString('Run',
             'Ma[X]iM Software Clock',Application.ExeName);
   end;
  end;
 finally
  reg.Free;
 end;
end;

procedure Tcform.N4Click(Sender: TObject);
begin
 Calendar.Show;
end;

end.
